

#     Access Client  for the  MIDASDataBaseAccess service

global env
source [file join $env(MIDASBASE) SOAP tcl MIDASAccessClient.tcl]    ;#   load default support procedures

global MIDASDataBaseAccessServerHost MIDASDataBaseAccessServerPort

if {[info exists MIDASDataBaseAccessServerHost] == 0} then {set MIDASDataBaseAccessServerHost localhost}
if {[info exists MIDASDataBaseAccessServerPort] == 0} then {set MIDASDataBaseAccessServerPort 8015}

variable uri "urn:MIDASDataBaseAccessServer"
variable proxy "http://$MIDASDataBaseAccessServerHost:$MIDASDataBaseAccessServerPort/MIDASDataBaseAccessServer"


SOAP::create MIDASDataBaseAccessClient__nodes -proxy $proxy -uri $uri -timeout 1000 \
     -name DBnodes \
     -params {nodeName string pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create MIDASDataBaseAccessClient__set -proxy $proxy -uri $uri -timeout 1000 \
     -name DBset \
     -params {nodeName string valueName string data string type string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply
     
SOAP::create MIDASDataBaseAccessClient__get -proxy $proxy -uri $uri -timeout 1000 \
     -name DBget \
     -params {nodeName string valueName string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create MIDASDataBaseAccessClient__delete -proxy $proxy -uri $uri -timeout 1000 \
     -name DBdelete \
     -params {nodeName string valueName string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply
     
SOAP::create MIDASDataBaseAccessClient__values -proxy $proxy -uri $uri -timeout 1000 \
     -name DBvalues \
     -params {nodeName string pattern string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create MIDASDataBaseAccessClient__type -proxy $proxy -uri $uri -timeout 1000 \
     -name DBtype \
     -params {nodeName string valueName string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create MIDASDataBaseAccessClient__AccessServerVerbose -proxy $proxy -uri $uri -timeout 1000 \
     -name AccessServerVerbose \
     -params {opt int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

package provide MIDASDataBaseAccessClient 1.0
